<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class All_products extends CI_Controller {

    public function __construct() {
        parent::__construct();

        $this->load->helper('url');
        $this->load->library("pagination"); 


        if (!$this->session->userdata('user_logged_in') || !company_url($this->session->userdata('company_slag'))) {
            redirect('login', 'refresh');
        }
        $this->load->vars(array(
            'global' => 'Available to all views',
            'header' => 'common/header',
            'left' => 'common/left',
            'footer' => 'common/footer'
        ));

        $this->load->model('User_model');
        $this->load->model('Item_model');
        $this->load->model('Invoice_model');
        $this->load->model('Setings_model');
        $this->load->model('Product_model');
        $this->load->model('Color_model');
        $this->load->model('Design_model');
    }

    public function index($start = null) {

//        $config = array();
//        $config["base_url"] = base_url() . "all_products/index/";
//        $config["total_rows"] = 250;
//        $config["per_page"] = 50;
//        $config["uri_segment"] = 3;

//        $this->pagination->initialize($config);

        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;

        $data["links"] = $this->pagination->create_links();


        $data['vendor_list'] = $this->Product_model->get_vendor();
//        $data['invoice_list'] = $this->Product_model->product_list($page);
        $this->load->view('invoice_list', $data);
    }

    public function invoice_list_1($start = null) {

        $config = array();
        $config["base_url"] = base_url() . "all_products/index/";
        $config["total_rows"] = 250;
        $config["per_page"] = 50;
        $config["uri_segment"] = 3;

        $this->pagination->initialize($config);

        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;

        $data["links"] = $this->pagination->create_links();


        $data['vendor_list'] = $this->Product_model->get_vendor();
//        $data['invoice_list'] = $this->Product_model->product_list($page);
        $this->load->view('invoice_list_1', $data);
    }

    public function product_data() {
        $dat = $this->uri->segment(3);        
        $status = $this->uri->segment(4);
        $q_data['vendor'] = $this->uri->segment(3);
        $q_data['is_commercial'] = $this->uri->segment(5);
        
       $draw = intval($this->input->get('draw'));
       $row = intval($this->input->get('start'));
       $page = intval($this->input->get('length'));
       $product = $this->Color_model->getAllProductData($row,$page,$q_data,$draw,$status);   
       $count = $this->Color_model->countProductData($q_data,$status);   
       $datacount=0;
       $data=array();
        if (!empty($product)) {
            $datacount=$count->id_count;
            foreach ($product->result() as $res) {
                $reference_link = ($res->isCommercial == 1) ? "commercialOptionsEdit":"optionsEdit";

                $action = '<a href="' . site_url("all_products/edit/" . $res->id) . '"><button class="btn btn-info btn-xs"><i class="fa fa-edit"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/copy/" . $res->id) . '"><button class="btn btn-primary btn-xs"><i class="fa fa-copy"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/delete/" . $res->id) . '"><button class="btn btn-danger btn-xs"><i class="fa fa-trash"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/attributesEdit/" . $res->id) . '"><button class="btn btn-info btn-xs"><i class="fa fa-edit"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/".$reference_link."/" . $res->id) . '"><button class="btn btn-warning btn-xs"><i class="fa fa-filter"></i></button></a>';




                $data[] = array(
                    $res->name,                  
                    substr(!empty($res->photo_id) ? $res->photo_id : '', 0, 100),
                    $res->vendor!='' ? $res->vendor : '',
                    $res->color!='' ? $res->color : '',
                    $res->delivered!='' ? $res->delivered : '',
                    $res->made_in!='' ? $res->made_in : '',
                    $action
                );
            }
        }

        $result = array(
            "draw" => $draw,
            "recordsTotal" => $datacount,
            "recordsFiltered" => $datacount,
            "data" => $data
        );       
        echo json_encode($result);
        exit();
    }
    
    public function product_data_by_photo_id() {
        $photo_id = $this->uri->segment(3);
        
       $draw = intval($this->input->get('draw'));
       $row = intval($this->input->get('start'));
       $page = intval($this->input->get('length'));
       $product = $this->Color_model->getAllProductDataByPhotoId($row,$page,$photo_id,$draw);   
       $count = $this->Color_model->countProductDataByPhotoId($photo_id);   
      $datacount=0;
      $data=array();
        if (!empty($product)) {
            $datacount=$count->id_count;
            foreach ($product->result() as $res) {
                $reference_link = ($res->isCommercial == 1) ? "commercialOptionsEdit":"optionsEdit";

                $action = '<a href="' . site_url("all_products/edit/" . $res->id) . '"><button class="btn btn-info btn-xs"><i class="fa fa-edit"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/copy/" . $res->id) . '"><button class="btn btn-primary btn-xs"><i class="fa fa-copy"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/delete/" . $res->id) . '"><button class="btn btn-danger btn-xs"><i class="fa fa-trash"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/attributesEdit/" . $res->id) . '"><button class="btn btn-info btn-xs"><i class="fa fa-edit"></i></button></a>
                               &nbsp;<a href="' . site_url("all_products/".$reference_link."/" . $res->id) . '"><button class="btn btn-warning btn-xs"><i class="fa fa-filter"></i></button></a>';




                $data[] = array(
                    $res->name,                  
                    substr(!empty($res->photo_id) ? $res->photo_id : '', 0, 100),
                    $res->vendor!='' ? $res->vendor : '',
                    $res->color!='' ? $res->color : '',
                    $res->delivered!='' ? $res->delivered : '',
                    $res->made_in!='' ? $res->made_in : '',
                    $action
                );
            }
        }

        $result = array(
            "draw" => $draw,
            "recordsTotal" => $datacount,
            "recordsFiltered" => $datacount,
            "data" => $data
        );       
        echo json_encode($result);
        exit();
    }
    
    

    public function newimage() {
        if (isset($_FILES['file']['name']) && $_FILES['file']['name'] != NULL){
            $large_photo = $this->upload_photo('file', rand(1111, 9999));
            //echo "<pre>";
            //print_r($large_photo);
            if(isset($large_photo['error'])){
                $large_photo['error']=0;
                echo json_encode($large_photo['error']);
            }else{
                echo json_encode($large_photo['success']);
            }
        }
    }
    
    public function removeExtraImage() {
        if (isset($_POST['extra_image_id']) && $_POST['extra_image_id'] != NULL){
            $sql = "SELECT id, filename FROM rugs_extra_images WHERE id =".$_POST['extra_image_id'];
            
            $query = $this->db->select('id, filename')
		->from('rugs_extra_images')
		->where('id', $_POST['extra_image_id'])
		->get();
		$num = $query->num_rows();
		if($num > 0){
        		$portfolio_data = $query->row();
        		$sql = "DELETE FROM rugs_extra_images WHERE id =".$_POST['extra_image_id'];
        		$this->db->delete('rugs_extra_images', array('id' => $_POST['extra_image_id']));  
        		return True;
        	}	
		return false;    
	}
    }


    public function newSvgImage() {
        if (isset($_FILES['file']['name']) && $_FILES['file']['name'] != NULL){
            $allowed_types = 'svg'; // Format should be 'svg|png|jpg' like that
            $large_photo = $this->upload_photo('file', rand(1111, 9999), $allowed_types);
            //echo "<pre>";
            //print_r($large_photo);
            if(isset($large_photo['error'])){
                $large_photo['error']=0;
                echo json_encode($large_photo['error']);
            }else{
                echo json_encode($large_photo['success']);
            }
        }
    }
    
    
    
    public function multiple_files(){
	  $this->load->library('upload');
	  $image = array();
	  $ImageCount = count($_FILES['extra_image']['name']);
		for($i = 0; $i < $ImageCount; $i++){
		    $_FILES['file']['name']       = $_FILES['extra_image']['name'][$i];
		    $_FILES['file']['type']       = $_FILES['extra_image']['type'][$i];
		    $_FILES['file']['tmp_name']   = $_FILES['extra_image']['tmp_name'][$i];
		    $_FILES['file']['error']      = $_FILES['extra_image']['error'][$i];
		    $_FILES['file']['size']       = $_FILES['extra_image']['size'][$i];

		    // File upload configuration
		    $uploadPath = './rug_images/';
		    $config['upload_path'] = $uploadPath;
		    $config['allowed_types'] = 'jpg|jpeg|png';

		    // Load and initialize upload library
		    $this->load->library('upload', $config);
		    $this->upload->initialize($config);

		    // Upload file to server
		    if($this->upload->do_upload('file')){
		        // Uploaded file data
		        $imageData = $this->upload->data();
		        $uploadImgData[$i]['filename'] = 'https://jeweldokan.in/admin/rug_images/' . $this->input->post('photo_id').'-+'.$imageData['file_name'];
		        $uploadImgData[$i]['photo_id'] = $this->input->post('photo_id');
		        $uploadImgData[$i]['type'] = $_POST['extra_image_type'][$i];

		    }
		}
		 if(!empty($uploadImgData)){
		    // Insert files data into the database
		    $this->db->insert_batch('rugs_extra_images', $uploadImgData);              
		}
	  }
	  
	

    public function newproduct() {
	
        if ($this->input->method(TRUE) == 'POST') {            
            $gs1 = $this->input->post('gs1');
            $msrp = $this->input->post('msrp');
            $length = $this->input->post('length');
            $width = $this->input->post('width');
            $height = $this->input->post('height');
            $price = $this->input->post('price');
            $oldCost=$this->input->post('old_cost');
            $cost = $this->input->post('cost');
            $size = $this->input->post('size');
            $searchsize=$this->input->post('searchsize');
            $shape = $this->input->post('shape');
            $stock = $this->input->post('stock');
            $shippingHeight = $this->input->post('shippingHeight');
            $shippingLength = $this->input->post('shippingLength');
            $shippingWidth = $this->input->post('shippingWidth');
            $add_name = $this->input->post('add_name');
            $add_val = $this->input->post('add_val');
            $show_front = $this->input->post('show_front');
            $show_back = $this->input->post('show_back');
            $sizesku=$this->input->post('sizesku');
            
            $collections=$this->input->post('collections');
            $design=$this->input->post('design');
            $vendorsku=$this->input->post('vendorsku');
            
            $searchsize2=array();
            if(!empty($this->input->post('searchsize'))){
                foreach($this->input->post('searchsize') as $value){
                    $searchsize2[]= $this->Product_model->getsearchsize(array('id' =>$value));
                }
               
            }


            $variations = array();
            $incId = 0;
            foreach ($gs1 as $key => $value) {
                $incId++;
                $variations[] = array(
                    'GS1' => $value,
                    'MSRP' => $msrp[$key],
                    'length' => $length[$key],
                    'width' => $width[$key],
                    'height' => $height[$key],
                    'old_price' =>$oldCost[$key],
                    'price'=>$price[$key],
                    'cost' => $cost[$key],
                    'size' => $size[$key],
                    'sizesku'=>$sizesku[$key],
                    //'shape' => $shape[$key],
                    'searchSize' => $searchsize2[$key],
                    'searchSizeFloor' => $size[$key],
                    'aliasSize' => $size[$key],
                    'option' => $incId,
                    'active' => 1,
                    'stock' => $stock[$key],
                    'shippingHeight' => $shippingHeight[$key],
                    'shippingLength' => $shippingLength[$key],
                    'shippingWidth' => $shippingWidth[$key],
                );
            }
      
            $variationsJson = json_encode($variations);
            if(!empty($this->input->post('category'))){
              $category_id=$this->input->post('category');    
              $category = $this->Product_model->category(array('id' =>$category_id));
            }else{
                $category_id=$this->Color_model->Add('categories',array('name' =>$this->input->post('create_category')));
                $category = $this->Product_model->category(array('id' =>$category_id));
            }
            if(!empty($this->input->post('vendor'))){
                $vendor_id=$this->input->post('vendor');
                $vendor = $this->Product_model->vendor(array('id' =>$vendor_id));
            }else{
                $vendor_id=$this->Color_model->Add('vendors',array('vendor_name' =>$this->input->post('create_vendor')));
                $vendor = $this->Product_model->vendor(array('id' =>$vendor_id));
            }
            
            
            /*if(!empty($this->input->post('color'))){
                $color_id=$this->input->post('color');
                $color = $this->Product_model->color(array('id' =>$color_id));
            }else{
                  $color_id=$this->Color_model->Add('color',array('color' =>$this->input->post('create_color')));
                  $color = $this->Product_model->color(array('id' =>$color_id));
            }*/
            
            if(!empty($this->input->post('quality'))){
                //$quality_id=$this->input->post('quality');
                //$quality = $this->Product_model->qualities(array('id' =>$quality_id));
                $quality_n = $this->input->post('quality');
            }else{
                 $quality_id=$this->Color_model->Add('rugs_qualities',array('name' =>$this->input->post('create_quality')));
                 $quality = $this->Product_model->qualities(array('id' =>$quality_id));
            }

            if(!empty($this->input->post('collections'))){            
                $collections_id=$this->input->post('collections');
                $collections = $this->Product_model->collections(array('id' =>$collections_id));
            }
            
            //==========3 image upload===========
            $image_name=$photo=$small_photo = $medium_photo = $large_photo = '';
            
            if(!empty($this->input->post('image_name')[0])){
                foreach($this->input->post('image_name') as $value){
                    //$photo=$value;
                    $photo=trim($value,'\'"');
                }
                $small_photo = $this->resize_image($photo, 200, 200,'small');
                $medium_photo=$this->resize_image($photo, 500, 500,'medium');
                $large_photo=$photo;
            }else{
                $small_photo ='';
                $medium_photo='';
                $large_photo='';
            }
            
            
            //==========3 image upload===========

            //=========== Svg Image Upload ========
            $svg = '';
            if(!empty($this->input->post('svg_image_name'))){
                $svg = trim($this->input->post('svg_image_name'), '\'"');
            }
            //=========== End ======================

            //==========CREATE ADDITIONAL DATA===========

            $additional_attributes = array();
            foreach ($add_name as $key => $value) {
                $additional_attributes[] = array(
                    'title' => $value,
                    'value' => $add_val[$key],
                    'visibleAdmin' => $show_back[$key],
                    'visibleFront' => $show_front[$key],
                );
            }

            $additional_attributesjson = json_encode($additional_attributes);
            if($this->input->post('material')){
            $attributes_parameters[]=array(
                "group"=>'material',
                "value"=> $this->input->post('material'),
                 "name"=>$this->input->post('material')
                );
            }
            if($collections){
            $attributes_parameters[]=array(
                "group"=>'type',
                "value"=> $collections[0]->name,
                 "name"=>$collections[0]->name
                );
            }
            $attributes = '';
            if($quality_n){

                $group=$this->input->post('group');
                $value=$this->input->post('value');
                $name=$this->input->post('att_name');
                $total_group=count($this->input->post('group'));

                $new_array=[];
                for($i=0;$i<$total_group;$i++){
                   $new_array[$i]=array(
                    "group"=>   $group[$i],
                    "value"=>   $value[$i],
                     "name"=>   $name[$i]
                    ); 
                }
                $attributes=json_encode($new_array);
            }
            
            //echo "<pre>";
            //print_r($attributes);
            //die('aaaa');
            //==========CREATE ADDITIONAL DATA===========
          
            $insertArr = array(
                'image'=>$photo,
                'thumb_pic'=>$small_photo,
                'picture'=>$medium_photo,
                'large_pic'=>$large_photo,
                'name' => $this->input->post('name'),
                '_vendor' => $vendor_id,
                'vendor' => $vendor[0]->vendor_name,
                '_category' => $category_id,
                'category' => $category[0]->name,
                '_collection'=>$collections_id,
                'collection'=> $collections[0]->name,
                'comm_category'=>$category[0]->name,
                'comm__category'=>$category_id,
                'comm_collection'=>$collections[0]->name,
                'comm__collection'=>$collections_id,
                'qualities'=>json_encode(array(0 => $quality_n)),
                'vendor_sku'=>$this->input->post('vendor_sku'),
                'attributes'=>$attributes,
                'photo_id' => $this->input->post('photo_id'),
                'isResidential' => "1",
                'attribute_set' => "Rugs",
                'description' => $this->input->post('description'),
                'color' => count($this->input->post('colors')) > 0 ? $this->input->post('colors')[0] : '',
                'colors' => json_encode($this->input->post('colors')),
                //'isResidential'=>$this->input->post('isResidential'),
                //'isCommercial'=>$this->input->post('isCommercial'),
                //'isFurniture'=>$this->input->post('isFurniture'),
                'new_arrival'=>$this->input->post('new_arrival'),
                //'promo'=>$this->input->post('promo'),
                'sale'=>$this->input->post('sale'),
                'custom_price'=>$this->input->post('custom_price'),
                'material' => $this->input->post('material'),
                'backing' => $this->input->post('backing'),
                'quality' => $quality_n,
                'keyword_additions' => $this->input->post('keyword_additions'),
                'variations' => $variationsJson,
                'thumb_pic' => 'https://jeweldokan.in/admin/rug_images/' . $small_photo,
                'picture' => 'https://jeweldokan.in/admin/rug_images/' . $medium_photo,
                'large_pic' => 'https://jeweldokan.in/admin/rug_images/' . $large_photo,
                'additional_attributes' => $additional_attributesjson,
                'date_added'=>date("Y-m-d,h:m:s"),
                'svg'=>$svg
            );
           
            //echo '<pre>';
            //print_r($this->input->post('customer'));die();

            $insertRow = $this->Product_model->insert_data('rugs_tmp', $insertArr);
		$extraImageCount = count($_FILES['extra_image']['name']);
		if($extraImageCount > 0){
			$this->multiple_files();
		}
            if ($insertRow) {
                if(!empty($this->input->post('customer')) && count($this->input->post('customer')) > 0 ){
                    $this->updateCustomerPortfolio($this->input->post('photo_id'), $this->input->post('customer'));    
                }
                
                $this->session->set_flashdata('message', 'Product added successfully!');
                redirect("all_products");
            }
        }

        $data['vendor_list'] = $this->Product_model->get_vendor();
        $data['category_list'] = $this->Product_model->category_list();
        $data['collection_list']=$this->Product_model->collectionlist();
        $data['size_drop'] = $this->Color_model->AllRecordWithWhere("search_sizes", array('id!=' => ''));
        $data['color_drop'] = $this->Color_model->AllRecordWithWhere("color", array('status' => '1'));
        $data['qualities_drop'] = $this->Color_model->AllRecordWithWhere("rugs_qualities",1); // , array('status' => '1')
        $data['shape_drop'] = $this->Color_model->AllRecordWithWhere("rugs_shape", array('status' => '1'));
        $data['consumar_product'] = FALSE;
        $this->load->view('invoice_create', $data);
    }

    public function newConsumerProduct(){
        $data['vendor_list'] = $this->Product_model->get_vendor();
        $data['category_list'] = $this->Product_model->category_list();
        $data['collection_list']=$this->Product_model->collectionlist();
        $data['size_drop'] = $this->Color_model->AllRecordWithWhere("search_sizes", array('id!=' => ''));
        $data['color_drop'] = $this->Color_model->AllRecordWithWhere("color", array('status' => '1'));
        $data['qualities_drop'] = $this->Color_model->AllRecordWithWhere("rugs_qualities",1); // , array('status' => '1')
        $data['shape_drop'] = $this->Color_model->AllRecordWithWhere("rugs_shape", array('status' => '1'));
        $data['customer_name_list'] = $this->User_model->customer_name_list();

        $data['consumar_product'] = TRUE;
        
        $this->load->view('invoice_create', $data);
    }


    public function updateCustomerPortfolio($photo_id, $customer_ids = array()){
	
        foreach($customer_ids as $customer){
            $portfolio_id = $this->getPortfolioId($customer, 'Custom Image');
            $data[] = array(
                'user_id'               => $customer,
                'portfolio'             => $portfolio_id,
                'photo_id'              => $photo_id,
                'size'                  => '1',
                'qty'                   => 1,
                'where_to'              => '',
                'comment'               => '',
                'customImage'           => '',
                'customImageThumbnail'  => '',
                'customInformation'     => '',
                'lastUpdate '           => date("Y-m-d"),
            );

            $this->sendMailToCustomer($customer, $photo_id);
        }

        $this->db->insert_batch('portfolios_items', $data);
    }
    
    
    public function getPortfolioId($customer_id = null, $portfolio_name = null){
    
    	$query = $this->db->select('user_id, id, name')
        ->from('portfolios')
        ->where('name', $portfolio_name)
        ->where('user_id', $customer_id)
        ->get();
        $num = $query->num_rows();
        if($num > 0){
        	$portfolio_data = $query->row();
        	return $portfolio_data->id;
        }else{
        	$data = array(
                'user_id'               => $customer_id,
                'name'                  => $portfolio_name,
                'active'                => '1'
            	);
            $this->db->insert('portfolios', $data);
            return $this->db->insert_id(); 
        }
    
    	return $portfolio_id;
    }


    public function sendMailToCustomer($customer_id, $photo_id = NULL){

        $query = $this->db->select('cust_id, cust_name, cust_email, CONCAT(cust_firstname, " ",cust_lastname) as name')
        ->from('cust_tbl')
        ->where('cust_id', $customer_id)
        ->get();
        $cust_details = $query->row();

        $to = $cust_details->cust_email;
        $to = "anindya.mishra22@gmail.com";
        $subject = "This is jeweldokan";
        
        $message = "Hello ".$cust_details->name.", <br>";
        $message .= "<b>One svg image is uploaded, photo id is - ".$photo_id." </b>";
        //$message .= "<h1>This is headline.</h1>";
        
        $header = "MIME-Version: 1.0\r\n";
        $header .= "Content-type: text/html\r\n";
         
        $retval = mail ($to,$subject,$message,$header);
         
        if( $retval == true ) {
            //echo "Message sent successfully...";
        }else {
            //echo "Message could not be sent...";
        }
    }


    public function edit($id) {
        
        if ($this->input->method(TRUE) == 'POST') {
            //echo "<pre>"; print_r($_FILES['extra_image']);
            //die();
            $gs1 = $this->input->post('gs1');
            $msrp = $this->input->post('msrp');
            $length = $this->input->post('length');
            $width = $this->input->post('width');
            $height = $this->input->post('height');
            $price = $this->input->post('price');
            $oldCost=$this->input->post('old_cost');
            $cost = $this->input->post('cost');
            $size = $this->input->post('size');
            $searchsize=$this->input->post('searchsize');
            //$shape = $this->input->post('shape');
            $stock = $this->input->post('stock');
            $shippingHeight = $this->input->post('shippingHeight');
            $shippingLength = $this->input->post('shippingLength');
            $shippingWidth = $this->input->post('shippingWidth');
            $add_name = $this->input->post('add_name');
            $add_val = $this->input->post('add_val');
            $show_front = $this->input->post('show_front');
            $show_back = $this->input->post('show_back');
            $sizesku=$this->input->post('sizesku');
            
            $collections=$this->input->post('collections');
            $design=$this->input->post('design');
            $vendorsku=$this->input->post('vendorsku');

            $searchsize2=array();
            if(!empty($this->input->post('searchsize'))){
                foreach($this->input->post('searchsize') as $value){
                    $searchsize2[]= $this->Product_model->getsearchsize(array('id' =>$value));
                }
               
            }


            $variations = array();
            $incId = 0;
            foreach ($gs1 as $key => $value) {
                $incId++;
                $variations[] = array(
                    'GS1' => $value,
                    'MSRP' => $msrp[$key],
                    'length' => $length[$key],
                    'width' => $width[$key],
                    'height' => $height[$key],
                    'old_price' =>$oldCost[$key],
                    'price'=>$price[$key],
                    'cost' => $cost[$key],
                    'size' => $size[$key],
                    'sizesku'=>$sizesku[$key],
                    'shape' => '',
                    'searchSize' => $searchsize2[$key],
                    'searchSizeFloor' => $size[$key],
                    'aliasSize' => $size[$key],
                    'option' => $incId,
                    'active' => 1,
                    'stock' => $stock[$key],
                    'shippingHeight' => $shippingHeight[$key],
                    'shippingLength' => $shippingLength[$key],
                    'shippingWidth' => $shippingWidth[$key],
                );
            }

            $variationsJson = json_encode($variations);

            if(!empty($this->input->post('category'))){
              $category_id=$this->input->post('category');    
              $category = $this->Product_model->category(array('id' =>$category_id));
            }else{
                $category_id=$this->Color_model->Add('categories',array('name' =>$this->input->post('create_category')));
                $category = $this->Product_model->category(array('id' =>$category_id));
            }
            if(!empty($this->input->post('vendor'))){
                $vendor_id=$this->input->post('vendor');
                $vendor = $this->Product_model->vendor(array('id' =>$vendor_id));
            }else{
                $vendor_id=$this->Color_model->Add('vendors',array('vendor_name' =>$this->input->post('create_vendor')));
                $vendor = $this->Product_model->vendor(array('id' =>$vendor_id));
            }
            
            
            /*if(!empty($this->input->post('color'))){
                $color_id=$this->input->post('color');
                $color = $this->Product_model->color(array('id' =>$color_id));
            }else{
                  $color_id=$this->Color_model->Add('color',array('color' =>$this->input->post('create_color')));
                  $color = $this->Product_model->color(array('id' =>$color_id));
            }*/
            
            if(!empty($this->input->post('quality'))){
                $quality_id=$this->input->post('quality');
                
                //$quality = $this->Product_model->qualities(array('id' =>$quality_id));
                //$quality_n = $quality[0]->name;
                $quality_n = $this->input->post('quality');
                //echo print_r($quality);exit;
            }else{
                 $quality_id=$this->Color_model->Add('rugs_qualities',array('name' =>$this->input->post('create_quality')));
                 $quality = $this->Product_model->qualities(array('id' =>$quality_id));
            }
                
                 if(!empty($this->input->post('collections'))){            
                    $collections_id=$this->input->post('collections');
                    $collections = $this->Product_model->collections(array('id' =>$collections_id));
                 }

             //==========3 image upload===========
             $image_name=$photo=$small_photo = $medium_photo = $large_photo = '';
            
            if(!empty($this->input->post('image_name')[0])){
                foreach($this->input->post('image_name') as $value){
                    //$photo=$value;
                    $photo=trim($value,'\'"');
                }
                $small_photo = $this->resize_image($photo, 200, 200,'small');
                $medium_photo=$this->resize_image($photo, 500, 500,'medium');
                $large_photo=$photo;
            }
            //echo 'Pradosh';
             
            //==========3 image upload===========
            //==========CREATE ADDITIONAL DATA===========

            $additional_attributes = array();
            foreach ($add_name as $key => $value) {
                $additional_attributes[] = array(
                    'title' => $value,
                    'value' => $add_val[$key],
                    'visibleAdmin' => $show_back[$key],
                    'visibleFront' => $show_front[$key],
                );
            }
            $additional_attributesjson = json_encode($additional_attributes);
            
            if($this->input->post('material')){
            $attributes_parameters[]=array(
                "group"=>'material',
                "value"=> $this->input->post('material'),
                 "name"=>$this->input->post('material')
                );
            }
            if($collections){
            $attributes_parameters[]=array(
                "group"=>'type',
                "value"=> $collections[0]->name,
                 "name"=>$collections[0]->name
                );
            }

            $group=$this->input->post('group');
            $value=$this->input->post('value');
            $name=$this->input->post('att_name');
            $total_group=count($this->input->post('group'));

            $new_array=[];
            for($i=0;$i<$total_group;$i++){
               $new_array[$i]=array(
                "group"=>   $group[$i],
                "value"=>   $value[$i],
                 "name"=>   $name[$i]
                ); 
            }
            $attributes=json_encode($new_array);
            //$attributes=json_encode($attributes_parameters);

            //==========CREATE ADDITIONAL DATA===========


         if(!empty($this->input->post('image_name')[0])){
            $insertArr = array(
                'image'=>$photo,
                'thumb_pic' => 'https://jeweldokan.in/admin/rug_images/' . $small_photo,
                'picture' => 'https://jeweldokan.in/admin/rug_images/' . $medium_photo,
                'large_pic' => 'https://jeweldokan.in/admin/rug_images/' . $large_photo,
                'name' => $this->input->post('name'),
                '_vendor' => $vendor_id,
                'vendor' => $vendor[0]->vendor_name,
                '_category' => $category_id,
                'category' => $category[0]->name,
                '_collection'=>$collections_id,
                'collection'=> $collections[0]->name,
                'comm_category'=>$category[0]->name,
                'comm__category'=>$category_id,
                'comm_collection'=>$collections[0]->name,
                'comm__collection'=>$collections_id,
                'qualities'=>json_encode(array(0 => $quality_n)),
                'vendor_sku'=>$this->input->post('vendor_sku'),
                'attributes'=>$attributes,
                'photo_id' => $this->input->post('photo_id'),
                'isResidential' => "1",
                'attribute_set' => "Rugs",
                'description' => $this->input->post('description'),
                'color' => count($this->input->post('colors')) > 0 ? $this->input->post('colors')[0] : '',
                'colors' => json_encode($this->input->post('colors')),
                //'isResidential'=>$this->input->post('isResidential'),
                //'isCommercial'=>$this->input->post('isCommercial'),
                //'isFurniture'=>$this->input->post('isFurniture'),
                'new_arrival'=>$this->input->post('new_arrival'),
                //'promo'=>$this->input->post('promo'),
                'sale'=>$this->input->post('sale'),
                'custom_price'=>$this->input->post('custom_price'),
                'material' => $this->input->post('material'),
                'backing' => $this->input->post('backing'),
                'quality' => $quality_n,
                'keyword_additions' => $this->input->post('keyword_additions'),
                'variations' => $variationsJson,
                'additional_attributes' => $additional_attributesjson,
                'last_update'=>date("Y-m-d,h:m:s")
            );
         }else{
             $insertArr = array(
                'name' => $this->input->post('name'),
                '_vendor' => $vendor_id,
                'vendor' => $vendor[0]->vendor_name,
                '_category' => $category_id,
                'category' => $category[0]->name,
                '_collection'=>$collections_id,
                'collection'=> $collections[0]->name,
                'comm_category'=>$category[0]->name,
                'comm__category'=>$category_id,
                'comm_collection'=>$collections[0]->name,
                'comm__collection'=>$collections_id,
                'qualities'=>json_encode(array(0 => $quality_n)),
                'vendor_sku'=>$this->input->post('vendor_sku'),
                'attributes'=>$attributes,
                'photo_id' => $this->input->post('photo_id'),
                'isResidential' => "1",
                'attribute_set' => "Rugs",
                'description' => $this->input->post('description'),
                'color' => count($this->input->post('colors')) > 0 ? $this->input->post('colors')[0] : '',
                'colors' => json_encode($this->input->post('colors')),
                //'isResidential'=>$this->input->post('isResidential'),
                //'isCommercial'=>$this->input->post('isCommercial'),
                //'isFurniture'=>$this->input->post('isFurniture'),
                'new_arrival'=>$this->input->post('new_arrival'),
                //'promo'=>$this->input->post('promo'),
                'sale'=>$this->input->post('sale'),
                'custom_price'=>$this->input->post('custom_price'),
                'material' => $this->input->post('material'),
                'backing' => $this->input->post('backing'),
                'quality' => $quality_n,
                'keyword_additions' => $this->input->post('keyword_additions'),
                'variations' => $variationsJson,
                'additional_attributes' => $additional_attributesjson,
                'last_update'=>date("Y-m-d,h:m:s")
            );
         }
            //echo '<pre>';
            //print_r($insertArr);die();

            	$updateRow = $this->Product_model->update_data('rugs_tmp', $insertArr, array('id' => $id));
		$extraImageCount = count($_FILES['extra_image']['name']);
		if($extraImageCount > 0){
			$this->multiple_files();
		}
            if ($updateRow) {
                $this->session->set_flashdata('message', 'Product updated successfully!');
                redirect("all_products");
            }
        }
        
        $data['vendor_list'] = $this->Product_model->get_vendor();
        $data['collection_list']=$this->Product_model->collectionlist();
        $data['category_list'] = $this->Product_model->category_list();
        $data['size_drop'] = $this->Color_model->AllRecordWithWhere("search_sizes", array('id!=' => ''));
        $data['color_drop'] = $this->Color_model->AllRecordWithWhere("color", array('status' => '1'));
        $data['product'] = $this->Product_model->product(array('id' => $id));
        
        $data['rugs_extra_images'] = $this->Product_model->get_rugs_extra_images(array('photo_id' => $data['product']->photo_id));
        $data['qualities_drop'] = $this->Color_model->AllRecord("rugs_qualities");
        $data['shape_drop'] = $this->Color_model->AllRecordWithWhere("rugs_shape", array('status' => '1'));
        //print_r($data);exit;
        $this->load->view('invoice_edit', $data);
    }

    public function copy($id) {
       
        if ($this->input->method(TRUE) == 'POST') {
            //echo "<pre>";print_r($_POST);
            //die();
            $gs1 = $this->input->post('gs1');
            $msrp = $this->input->post('msrp');
            $length = $this->input->post('length');
            $width = $this->input->post('width');
            $height = $this->input->post('height');
            $price = $this->input->post('price');
            $oldCost=$this->input->post('old_cost');
            $cost = $this->input->post('cost');
            $size = $this->input->post('size');
            $searchsize=$this->input->post('searchsize');
            $shape = $this->input->post('shape');
            $stock = $this->input->post('stock');
            $shippingHeight = $this->input->post('shippingHeight');
            $shippingLength = $this->input->post('shippingLength');
            $shippingWidth = $this->input->post('shippingWidth');
            $add_name = $this->input->post('add_name');
            $add_val = $this->input->post('add_val');
            $show_front = $this->input->post('show_front');
            $show_back = $this->input->post('show_back');
            $sizesku=$this->input->post('sizesku');
            
            $collections=$this->input->post('collections');
            $design=$this->input->post('design');
            $vendorsku=$this->input->post('vendorsku');
            
            $searchsize2=array();
            if(!empty($this->input->post('searchsize'))){
                foreach($this->input->post('searchsize') as $value){
                    $searchsize2[]= $this->Product_model->getsearchsize(array('id' =>$value));
                }
               
            }


            $variations = array();
            $incId = 0;
            foreach ($gs1 as $key => $value) {
                $incId++;
                $variations[] = array(
                    'GS1' => $value,
                    'MSRP' => $msrp[$key],
                    'length' => $length[$key],
                    'width' => $width[$key],
                    'height' => $height[$key],
                    'old_price' =>$oldCost[$key],
                    'price'=>$price[$key],
                    'cost' => $cost[$key],
                    'size' => $size[$key],
                    'sizesku'=>$sizesku[$key],
                    'shape' => $shape[$key],
                    'searchSize' => $searchsize2[$key],
                    'searchSizeFloor' => $size[$key],
                    'aliasSize' => $size[$key],
                    'option' => $incId,
                    'active' => 1,
                    'stock' => $stock[$key],
                    'shippingHeight' => $shippingHeight[$key],
                    'shippingLength' => $shippingLength[$key],
                    'shippingWidth' => $shippingWidth[$key],
                );
            }

           $variationsJson = json_encode($variations);

            if(!empty($this->input->post('category'))){
              $category_id=$this->input->post('category');    
              $category = $this->Product_model->category(array('id' =>$category_id));
            }else{
                $category_id=$this->Color_model->Add('categories',array('name' =>$this->input->post('create_category')));
                $category = $this->Product_model->category(array('id' =>$category_id));
            }
            if(!empty($this->input->post('vendor'))){
                $vendor_id=$this->input->post('vendor');
                $vendor = $this->Product_model->vendor(array('id' =>$vendor_id));
            }else{
                $vendor_id=$this->Color_model->Add('vendors',array('vendor_name' =>$this->input->post('create_vendor')));
                $vendor = $this->Product_model->vendor(array('id' =>$vendor_id));
            }
            
            
            /*if(!empty($this->input->post('color'))){
                $color_id=$this->input->post('color');
                $color = $this->Product_model->color(array('id' =>$color_id));
            }else{
                  $color_id=$this->Color_model->Add('color',array('color' =>$this->input->post('create_color')));
                  $color = $this->Product_model->color(array('id' =>$color_id));
            }*/
            
            if(!empty($this->input->post('quality'))){
                $quality_id=$this->input->post('quality');
                
                //$quality = $this->Product_model->qualities(array('id' =>$quality_id));
                //$quality_n = $quality[0]->name;
                $quality_n = $this->input->post('quality');
                //echo print_r($quality);exit;
            }else{
                 $quality_id=$this->Color_model->Add('rugs_qualities',array('name' =>$this->input->post('create_quality')));
                 $quality = $this->Product_model->qualities(array('id' =>$quality_id));
            }
                
                 if(!empty($this->input->post('collections'))){            
                    $collections_id=$this->input->post('collections');
                    $collections = $this->Product_model->collections(array('id' =>$collections_id));
                 }

             //==========3 image upload===========
             $image_name=$photo=$small_photo = $medium_photo = $large_photo = '';
            
            if(!empty($this->input->post('image_name')[0])){
                foreach($this->input->post('image_name') as $value){
                    //$photo=$value;
                    $photo=trim($value,'\'"');
                }
                $small_photo = $this->resize_image($photo, 200, 200,'small');
                $medium_photo=$this->resize_image($photo, 500, 500,'medium');
                $large_photo=$photo;
            }
            //echo 'Pradosh';
             
            //==========3 image upload===========
            //==========CREATE ADDITIONAL DATA===========

            $additional_attributes = array();
            foreach ($add_name as $key => $value) {
                $additional_attributes[] = array(
                    'title' => $value,
                    'value' => $add_val[$key],
                    'visibleAdmin' => $show_back[$key],
                    'visibleFront' => $show_front[$key],
                );
            }
            $additional_attributesjson = json_encode($additional_attributes);
            
            if($this->input->post('material')){
            $attributes_parameters[]=array(
                "group"=>'material',
                "value"=> $this->input->post('material'),
                 "name"=>$this->input->post('material')
                );
            }
            if($collections){
            $attributes_parameters[]=array(
                "group"=>'type',
                "value"=> $collections[0]->name,
                 "name"=>$collections[0]->name
                );
            }

            $group=$this->input->post('group');
            $value=$this->input->post('value');
            $name=$this->input->post('att_name');
            $total_group=count($this->input->post('group'));

            $new_array=[];
            for($i=0;$i<$total_group;$i++){
               $new_array[$i]=array(
                "group"=>   $group[$i],
                "value"=>   $value[$i],
                 "name"=>   $name[$i]
                ); 
            }
            $attributes=json_encode($new_array);
            
            //echo "<pre>";
            //print_r($attributes);
            //die('aaaa');
            //==========CREATE ADDITIONAL DATA===========
          
            
           
           
           if(isset($this->input->post('image_name')[0])){
            $insertArr = array(
                'image'=>$photo,
                'thumb_pic' => 'https://jeweldokan.in/admin/rug_images/' . $small_photo,
                'picture' => 'https://jeweldokan.in/admin/rug_images/' . $medium_photo,
                'large_pic' => 'https://jeweldokan.in/admin/rug_images/' . $large_photo,
                'name' => $this->input->post('name'),
                '_vendor' => $vendor_id,
                'vendor' => $vendor[0]->vendor_name,
                '_category' => $category_id,
                'category' => $category[0]->name,
                '_collection'=>$collections_id,
                'collection'=> $collections[0]->name,
                'comm_category'=>$category[0]->name,
                'comm__category'=>$category_id,
                'comm_collection'=>$collections[0]->name,
                'comm__collection'=>$collections_id,
                'qualities'=>json_encode(array(0 => $quality_n)),
                'vendor_sku'=>$this->input->post('vendor_sku'),
                'attributes'=>$attributes,
                'photo_id' => $this->input->post('photo_id'),
                'isResidential' => "1",
                'attribute_set' => "Rugs",
                'description' => $this->input->post('description'),
                'color' => count($this->input->post('colors')) > 0 ? $this->input->post('colors')[0] : '',
                'colors' => json_encode($this->input->post('colors')),
                //'isResidential'=>$this->input->post('isResidential'),
                //'isCommercial'=>$this->input->post('isCommercial'),
                //'isFurniture'=>$this->input->post('isFurniture'),
                'new_arrival'=>$this->input->post('new_arrival'),
                //'promo'=>$this->input->post('promo'),
                'sale'=>$this->input->post('sale'),
                'custom_price'=>$this->input->post('custom_price'),
                'material' => $this->input->post('material'),
                'backing' => $this->input->post('backing'),
                'quality' => $quality_n,
                'keyword_additions' => $this->input->post('keyword_additions'),
                'variations' => $variationsJson,
                'additional_attributes' => $additional_attributesjson,
                'last_update'=>date("Y-m-d,h:m:s")
            );
         }else{
             $insertArr = array(
                'name' => $this->input->post('name'),
                '_vendor' => $vendor_id,
                'vendor' => $vendor[0]->vendor_name,
                '_category' => $category_id,
                'category' => $category[0]->name,
                '_collection'=>$collections_id,
                'collection'=> $collections[0]->name,
                'comm_category'=>$category[0]->name,
                'comm__category'=>$category_id,
                'comm_collection'=>$collections[0]->name,
                'comm__collection'=>$collections_id,
                'qualities'=>json_encode(array(0 => $quality_n)),
                'vendor_sku'=>$this->input->post('vendor_sku'),
                'attributes'=>$attributes,
                'photo_id' => $this->input->post('photo_id'),
                'isResidential' => "1",
                'attribute_set' => "Rugs",
                'description' => $this->input->post('description'),
                'color' => count($this->input->post('colors')) > 0 ? $this->input->post('colors')[0] : '',
                'colors' => json_encode($this->input->post('colors')),
                //'isResidential'=>$this->input->post('isResidential'),
                //'isCommercial'=>$this->input->post('isCommercial'),
                //'isFurniture'=>$this->input->post('isFurniture'),
                'new_arrival'=>$this->input->post('new_arrival'),
                //'promo'=>$this->input->post('promo'),
                'sale'=>$this->input->post('sale'),
                'custom_price'=>$this->input->post('custom_price'),
                'material' => $this->input->post('material'),
                'backing' => $this->input->post('backing'),
                'quality' => $quality_n,
                'keyword_additions' => $this->input->post('keyword_additions'),
                'variations' => $variationsJson,
                'additional_attributes' => $additional_attributesjson,
                'last_update'=>date("Y-m-d,h:m:s")
            );
         }
            //echo '<pre>';
            //print_r($insertArr);die();

            $insertRow = $this->Product_model->insert_data('rugs_tmp', $insertArr);
            $extraImageCount = count($_FILES['extra_image']['name']);
		if($extraImageCount > 0){
			$this->multiple_files();
		}

            if ($insertRow) {
                $this->session->set_flashdata('message', 'Product added successfully!');
                redirect("all_products");
          }
        }
        
        $data['vendor_list'] = $this->Product_model->get_vendor();
        $data['collection_list']=$this->Product_model->collectionlist();
        $data['category_list'] = $this->Product_model->category_list();
        $data['size_drop'] = $this->Color_model->AllRecordWithWhere("search_sizes", array('id!=' => ''));
        $data['color_drop'] = $this->Color_model->AllRecordWithWhere("color", array('status' => '1'));
        $data['product'] = $this->Product_model->product(array('id' => $id));
        $data['rugs_extra_images'] = $this->Product_model->get_rugs_extra_images(array('photo_id' => $data['product']->photo_id));
        $data['qualities_drop'] = $this->Color_model->AllRecord("rugs_qualities");
        $data['shape_drop'] = $this->Color_model->AllRecordWithWhere("rugs_shape", array('status' => '1'));

        $this->load->view('invoice_copy', $data);
    }
    
    public function attributesEdit($id){
        if ($this->input->method(TRUE) == 'POST') {
            $group=$this->input->post('group');
            $value=$this->input->post('value');
            $name=$this->input->post('name');
            $total_group=count($this->input->post('group'));
            $total_value=count($this->input->post('value'));
            $total_name=count($this->input->post('name'));
            
            $productId=$this->input->post('product_id');
            $new_array=[];
            for($i=0;$i<$total_group;$i++){
               $new_array[$i]=array(
                "group"=>$group[$i],
                "value"=> $value[$i],
                 "name"=>$name[$i]
                ); 
            }
            $attributes=json_encode($new_array);
            $insertArr = array(
                'attributes'=>$attributes,
                'last_update'=>date("Y-m-d,h:m:s")
            );
            
            $updateRow = $this->Product_model->update_data('rugs_tmp', $insertArr, array('id' => $productId));
            $this->session->set_flashdata('message', 'Attributes Updates successfully!');
            redirect("/all_products");
         }
        $data['attributes']= $this->Color_model->getAllattributes("rugs_tmp", array('id' =>$id));
        $data['productId']= $id;
        $this->load->view('attributesEdit', $data);
        
    }

    public function commercialOptionsEdit($id){    

        $data['quality'] = $this->Design_model->AllRecord("rugs_qualities", array('id', 'name'))->result();
        $data['design'] = $this->Design_model->AllRecord("design", array('id', 'design'))->result();
        $data['type'] = $this->Design_model->AllRecord("types", array('id', 'name'))->result();
        $data['material'] = $this->Design_model->AllRecord("materials", array('id', 'name'))->result();
        $data['collections'] = $this->Design_model->AllRecord("collections", array('id', 'name'))->result();
        $data['product'] = $this->Product_model->product(array('id' => $id));
        $data['attributes'] = json_decode($data['product']->attributes);

        $data['sector'] = $this->db->query('SELECT DISTINCT sector as name from rugs_tmp ORDER BY sector ASC')->result();

        $data['color_drop'] = $this->Color_model->AllRecordWithWhere("color", array('status' => '1'));
        $next = $this->db->query('SELECT id from rugs_tmp where id > '.$id.' AND isCommercial=1 AND _vendor = '.$data['product']->_vendor.' LIMIT 1')->result();
        if(!count($next) > 0){
            $next = $this->db->query('SELECT id from rugs_tmp where isCommercial=1 AND _vendor = '.$data['product']->_vendor.' ORDER BY id ASC LIMIT 1')->result();
        }
        $data['next_id'] = $next[0]->id;

        $data['selected_material'] = array();
        $data['selected_design'] = array();
        $data['selected_type'] = array();
        $data['selected_qualities'] = array();

        if($this->json_validator($data['product']->attributes)){
           foreach(json_decode($data['product']->attributes) as $attribute){
                if($attribute->group == 'design'){
                     array_push($data['selected_design'], $attribute->name);
                }
                if($attribute->group == 'material'){
                    array_push($data['selected_material'], $attribute->name);
                }
                if($attribute->group == 'type'){
                     array_push($data['selected_type'], $attribute->name);
                }
            } 
        }

        if($this->json_validator($data['product']->qualities)){
           foreach(json_decode($data['product']->qualities) as $qualities){
                 array_push($data['selected_qualities'], $qualities);              
            } 
        }
        
        //echo "<pre>"; print_r($data);exit;
        $this->load->view('commercialAttributes', $data);
    }


    public function optionsEdit($id){          
        
        $data['quality'] = $this->Design_model->AllRecord("rugs_qualities", array('id', 'name'))->result();
        $data['design'] = $this->Design_model->AllRecord("design", array('id', 'design'))->result();
        $data['type'] = $this->Design_model->AllRecord("types", array('id', 'name'))->result();
        $data['material'] = $this->Design_model->AllRecord("materials", array('id', 'name'))->result();
        $data['collections'] = $this->Design_model->AllRecord("collections", array('id', 'name'))->result();
        $data['product'] = $this->Product_model->product(array('id' => $id));
        $data['attributes'] = json_decode($data['product']->attributes);
        $data['color_drop'] = $this->Color_model->AllRecordWithWhere("color", array('status' => '1'));

        $next = $this->db->query('SELECT id from rugs_tmp where id > '.$id.' AND isCommercial=0 AND _vendor = '.$data['product']->_vendor.' LIMIT 1')->result();
        if(!count($next) > 0){
            $next = $this->db->query('SELECT id from rugs_tmp where isCommercial=0 AND _vendor = '.$data['product']->_vendor.' ORDER BY id ASC LIMIT 1')->result();
        }
        $data['next_id'] = $next[0]->id;

        $data['selected_material'] = array();
        $data['selected_design'] = array();
        $data['selected_type'] = array();

        if($this->json_validator($data['product']->attributes)){
           foreach(json_decode($data['product']->attributes) as $attribute){
                if($attribute->group == 'design'){
                     array_push($data['selected_design'], $attribute->name);
                }
                if($attribute->group == 'material'){
                    array_push($data['selected_material'], $attribute->name);
                }
                if($attribute->group == 'type'){
                     array_push($data['selected_type'], $attribute->name);
                }
            } 
        }
        
        //echo "<pre>"; print_r($data);exit;
        $this->load->view('attributes', $data);
    }



    public function save_attributes(){
        $arr_attribute = array();
        $data=$this->input->post();
        if(count($this->input->post('design')) > 0){
            foreach($this->input->post('design') as $value){
                $arr_attribute[] = array('group'=>'design', 'value'=>$value, 'name'=>$value );
            }
        }
        if(!empty($this->input->post('create_design'))){     
            $design = $this->Color_model->AllRecordWithWhere('design', array('design' => $this->input->post('create_design')));

            if(!$design){
               $design_id=$this->Color_model->Add('design', array('design' =>$this->input->post('create_design'))); 
               $arr_attribute[] = array('group'=>'design', 'value'=>$this->input->post('create_design'), 'name'=>$this->input->post('create_design') );
            }                     
        } 

        if(count($this->input->post('type')) > 0){
            foreach($this->input->post('type') as $value){
                $arr_attribute[] = array('group'=>'type', 'value'=>$value, 'name'=>$value );
            }
        }
        if(!empty($this->input->post('create_type'))){     
            $type = $this->Color_model->AllRecordWithWhere('types', array('name' => $this->input->post('create_type')));

            if(!$type){
               $type_id=$this->Color_model->Add('types', array('name' =>$this->input->post('create_type'))); 
               $arr_attribute[] = array('group'=>'type', 'value'=>$this->input->post('create_type'), 'name'=>$this->input->post('create_type') );
            }                     
        }

        if(count($this->input->post('material')) > 0){
            foreach($this->input->post('material') as $value){                
                $arr_attribute[] = array('group'=>'material', 'value'=>$value, 'name'=>$value );
            }
        }
        if(!empty($this->input->post('create_material'))){     
            $material = $this->Color_model->AllRecordWithWhere('materials', array('name' => $this->input->post('create_material')));

            if(!$material){
               $material_id=$this->Color_model->Add('materials', array('name' =>$this->input->post('create_material'))); 
               $arr_attribute[] = array('group'=>'material', 'value'=>$this->input->post('create_material'), 'name'=>$this->input->post('create_material') );
            }    
        }
        
        if(!empty($this->input->post('designer'))){
            $arr_designer = explode('_', $this->input->post('designer'));
        }

        if(!empty($this->input->post('create_color'))){    
            $color =  $this->Color_model->AllRecordWithWhere("color", array('color' => $this->input->post('create_color')));

            if(!$color){
               $color_id=$this->Color_model->Add('color', array('color'=>$this->input->post('create_color'))); 
               array_push($_POST['colors'], $this->input->post('create_color'));

            }    
        }

        $updateArr = array(
            'attributes' => json_encode($arr_attribute),
            'quality' => $this->input->post('quality'),
            'designer' => $arr_designer[1],
            '_designer' => $arr_designer[0],            
            'color' => count($this->input->post('colors')) > 0 ? $this->input->post('colors')[0] : '',
            'colors' => json_encode($this->input->post('colors')),
            'last_update'=>date("Y-m-d,h:m:s")
        );

        if($this->input->post('sector') && !empty($this->input->post('sector'))){
            $updateArr['sector'] = $this->input->post('sector');
            
        }
        if(!empty($this->input->post('create_sector'))){           
            $updateArr['sector'] = $this->input->post('create_sector');
        }
        
        if(!empty($this->input->post('collection'))){
            $arr_collection = explode('_', $this->input->post('collection'));
            $updateArr['collection'] = $arr_collection[1];
            $updateArr['_collection'] = $arr_collection[0];
        }
        if(!empty($this->input->post('create_collection'))){ 
            $collection =  $this->Color_model->AllRecordWithWhere("collections", array('name' => $this->input->post('create_collection')));
            if(!$collection){
                $collection_id=$this->Color_model->Add('collections', array('name'=>$this->input->post('create_collection'))); 
                $updateArr['collection'] = $this->input->post('create_collection');
                $updateArr['_collection'] = $collection_id;
            } 
        }  

        if(!empty($this->input->post('create_quality'))){    
            $color =  $this->Color_model->AllRecordWithWhere("rugs_qualities", array('name' => $this->input->post('create_quality')));

            if(!$color){
               $color_id=$this->Color_model->Add('rugs_qualities', array('name'=>$this->input->post('create_quality'))); 
               array_push($_POST['qualities'], $this->input->post('create_quality'));
            }    
        }
        if($this->input->post('qualities') && count($this->input->post('qualities')) > 0){
            $updateArr['qualities'] = json_encode($this->input->post('qualities'));
        }
        

        $updateRow = $this->Product_model->update_data('rugs_tmp', $updateArr, array('id'=>$this->input->post('id')));

        echo json_encode(array('success'=>true));
    }


    public function json_validator($data) {
        if (!empty($data)) {
            return is_string($data) && 
              is_array(json_decode($data, true)) ? true : false;
        }
        return false;
    }


    
    public function check_sku(){
        $sku_value=$this->input->post('sku_value');
        $check_sku_presentOrNot=$this->Product_model->checkSKU(array('photo_id' =>$sku_value));
        if(empty($check_sku_presentOrNot)){
             $result_html=1;
             echo json_encode($result_html);
            
        }else{
            $result_html=0;
            echo json_encode($result_html);
        }
    }


    
    public function invoice_id() {
        $last_id = $this->Invoice_model->get_from_table('sale_invoice', 'max(sale_invoice_id) lastId', 'sale_invoice_id > 0');
        $invoice_id = 'S-20-21-' . sprintf('%06d', ($last_id[0]->lastId - 119));
        $check_invoice = $this->Invoice_model->get_from_table("sale_invoice", "*", "invoice_no ='" . $invoice_id . "'");

        if (count($check_invoice) == 0) {
            return $invoice_id;
        } else {
            return 'S-20-21-' . sprintf('%06d', ($last_id[0]->lastId - 118));
        }
    }

    /* public function invoice_id(){
      $last_id = $this->Invoice_model->get_from_table('sale_invoice','max(sale_invoice_id) lastId','sale_invoice_id > 0');
      $invoice_id = 'S-19-20-'.sprintf('%06d', ($last_id[0]->lastId-73));
      $check_invoice = $this->Invoice_model->get_from_table("sale_invoice","*","invoice_no ='".$invoice_id."'");

      if (count($check_invoice) == 0) {
      return $invoice_id;
      } else {
      return 'S-19-20-'.sprintf('%06d', ($last_id[0]->lastId-72));
      }
      } */

    public function generate_invoice() {
        $form_data = $this->input->post('invoice_basic');
        $sum_amounts = $this->input->post('items_tot');
        $item_data = $this->input->post('items');
        $userState = $this->input->post('userState');
        $status = $this->input->post('status');

        $data['invoice_data'] = array(
            'invoice_no' => $form_data[1]['value'],
            'customer_id' => $form_data[0]['value'],
            'order_no' => $form_data[2]['value'],
            'invoice_date' => date('Y-m-d', strtotime(str_replace('/', '-', $form_data[3]['value']))),
            'due_date' => date('Y-m-d', strtotime(str_replace('/', '-', $form_data[4]['value']))),
            'total' => $sum_amounts['final_total'],
            'sub_total' => $sum_amounts['sub_total'],
            'cgst_total' => $sum_amounts['cgst'],
            'sgst_total' => $sum_amounts['sgst'],
            'igst_total' => $sum_amounts['igst'],
            'status' => $status,
            'date_added' => date('Y-m-d')
        );
        $check_invoice = $this->Invoice_model->get_from_table('sale_invoice', '*', array('invoice_no' => $form_data[1]['value']));
        if (count($check_invoice) > 0) {
            $sale_invoice_id = $check_invoice[0]->sale_invoice_id;
            $this->Invoice_model->update_data('sale_invoice', $data['invoice_data'], array('invoice_no' => $form_data[1]['value'], 'sale_invoice_id' => $sale_invoice_id));
        } else {
            $sale_invoice_id = $this->Invoice_model->insert_data('sale_invoice', $data['invoice_data']);
        }

        if (count($item_data) > 0) {
            $stock_items = array();
            foreach ($item_data as $key => $value) {
                if ($value['item_name'] != '') {
                    $item_details[] = array(
                        'sale_invoice_id' => $sale_invoice_id,
                        'item_id' => $value['item_id'],
                        'item' => $value['item_name'],
                        'hsn_code' => $value['hsn_code'],
                        'gst_rate' => $value['item_gst'],
                        'qty' => $value['quantity'],
                        'uom' => $value['uom'],
                        'rate' => $value['unit_price'],
                        'discount' => $value['discount'],
                        'amount' => $value['price'],
                        'cgst' => (($userState == 19) ? (((($value['quantity'] * $value['unit_price']) - ((($value['quantity'] * $value['unit_price']) * $value['discount']) / 100)) * ($value['item_gst'] / 2)) / 100) : 0),
                        'sgst' => (($userState == 19) ? (((($value['quantity'] * $value['unit_price']) - ((($value['quantity'] * $value['unit_price']) * $value['discount']) / 100)) * ($value['item_gst'] / 2)) / 100) : 0),
                        'igst' => (($userState != 19) ? (((($value['quantity'] * $value['unit_price']) - ((($value['quantity'] * $value['unit_price']) * $value['discount']) / 100)) * $value['item_gst']) / 100) : 0)
                    );

                    if ($value['item_id'] > 0) {
                        $stock_items[] = array(
                            'item_id' => $value['item_id'],
                            'qty_sale' => $value['quantity'],
                            'qty_purchase' => 0,
                            'inv_bill_id' => $sale_invoice_id,
                            'date_added' => date('Y-m-d'),
                            'is_note' => 1
                        );
                    }
                }
            }

            // $data['customer_details'] = $this->User_model->get_user_data($form_data[0]['value']);
            // $data['item_details'] = $item_details;
            if (count($check_invoice) > 0) {
                $sale_invoice_id = $check_invoice[0]->sale_invoice_id;
                $this->Invoice_model->delete_data('invoice_item_detail', array('sale_invoice_id' => $sale_invoice_id));
                $this->Invoice_model->delete_data('item_stock', array('inv_bill_id' => $sale_invoice_id, 'is_note' => 1));
            }
            $this->Invoice_model->insert_data_batch('invoice_item_detail', $item_details);
            if (count($stock_items) > 0) {
                $this->Invoice_model->insert_data_batch('item_stock', $stock_items);
            }
        }

        echo $form_data[1]['value'];
    }

    public function invoice_print($key_invoice) {
        $data['setings'] = $this->Setings_model->get_setings();
        $data['invoice_id'] = $key_invoice;
        $invoice_details = $this->Invoice_model->get_from_table('sale_invoice', '*', array('invoice_no' => $data['invoice_id']));
        $data['invoice_data'] = (array) $invoice_details[0];
        $data['item_details'] = $this->Invoice_model->get_from_table('invoice_item_detail', '*', array('sale_invoice_id' => $data['invoice_data']['sale_invoice_id']));
        $data['payment_done'] = $this->Invoice_model->get_from_table('invoice_payment', '*', array('sale_invoice_id' => $data['invoice_data']['sale_invoice_id']));

        $data['is_editable'] = (count($data['payment_done']) > 0) ? FALSE : TRUE;
        // $data['item_details'] = $this->Invoice_model->get_invoice_item_details(array('sale_invoice_id' => $data['invoice_data']['sale_invoice_id']));
        $data['customer_details'] = $this->User_model->get_user_data($data['invoice_data']['customer_id']);
        $this->load->view('invoice_print', $data);
    }

    private function upload_photo($field_name, $filename, $allowed_types = NULL) {
                $config=array();
                $config['upload_path'] = './rug_images/';

                if(is_null($allowed_types)){
                    $config['allowed_types'] = 'gif|jpg|png|jpeg';
                }else{
                    $config['allowed_types'] = $allowed_types;
                }
                
                //$config['max_width']  = '1000';
                //$config['max_height']  = '1500';
                $config['file_name'] = $filename;
                $config['encrypt_name'] = TRUE;
        $this->load->library('upload', $config);
        
        if (!$this->upload->do_upload($field_name)) {
            return $error = array('error' => $this->upload->display_errors());
        } else {
           
            $upload = $this->upload->data();
            return array('success' =>$upload['file_name']); ;
        }
    }
    
    
    
    function resize_image($file, $w, $h,$type=null,$crop=false) {
                $image_name = 'rug_images/'.$file; 
                $photo_extn=substr($file, strrpos($file, '.')+1);
                //$file_name = array_pop(array_reverse(explode(".", $file)));;
                $value = explode(".", $file);
                $extension = strtolower(array_pop($value));   //Line 32
               // the file name is before the last "."
               $file_name = array_shift($value);  //Line 34
                 $new_file_name='';
                 if(!empty($type)){
                     $new_file_name=$file_name.'_'.$type.'.'.$photo_extn;
                 }
                 
                   //The location of the file that we want to copy.
                    $fileToCopy = 'rug_images/'.$file;
                    
                    //The file path that we want to copy it to.
                    $destinationOfCopy = 'rug_images/'.$new_file_name;
                    
                    //Copy the file using PHP's copy function.
                    $success = copy($fileToCopy, $destinationOfCopy);
                
                
                list($width, $height) = getimagesize('rug_images/'.$new_file_name);
                $r = $width / $height;
                if($crop){
                    if ($width > $height){
                        $width = ceil($width-($width*abs($r-$w/$h)));
                    }else{
                        $height = ceil($height-($height*abs($r-$w/$h)));
                    }
                    $newwidth = $w;
                    $newheight = $h;
                }else{
                    if($w/$h > $r){
                        $newwidth = $h*$r;
                        $newheight = $h;
                    }else{
                        $newheight = $w/$r;
                        $newwidth = $w;
                    }
                }
                
                $src="";
                $photo_extn;
                switch (strtolower($photo_extn)) {
                                    case 'jpg' :
                                    case 'jpeg':  //header('Content-Type: image/jpeg');
                                                 $image_p = imagecreatetruecolor($newwidth, $newheight);    
                                                 $image = imagecreatefromjpeg('rug_images/'.$new_file_name);
                                                 ob_start();
                                                 imagejpeg($image_p, "rug_images/".$new_file_name.".jpg", 100);
                                                 $image_data = ob_get_contents();
                                                 ob_end_flush();
                                                break;
                                    case 'gif' :  //header('Content-Type: image/gif');
                                                 $image_p = imagecreatetruecolor($newwidth, $newheight); 
                                                 $image = imagecreatefromgif('rug_images/'.$new_file_name);
                                                 ob_start();
                                                 imagegif($image_p, "rug_images/".$new_file_name.".gif",100);
                                                 $image_data = ob_get_contents();
                                                 ob_end_flush();
                                                 break;
                                    case 'png' :  //header('Content-Type: image/png');
                                                 $image_p = imagecreatetruecolor($newwidth, $newheight); 
                                                 $image = imagecreatefrompng('rug_images/'.$new_file_name);
                                                 ob_start();
                                                 @imagepng($new_file_name,NUll,9);
                                                 $image_data = ob_get_contents();
                                                 ob_end_flush();
                                                 break;
                                    default    : $stop = true;
                                                break;
                                }
                return $new_file_name;
                        
            }

}

?>
