<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Export_products extends CI_Controller {
    
    public function __construct() {
        parent::__construct();
         if (! $this->session->userdata ( 'user_logged_in' ) || !company_url($this->session->userdata ('company_slag'))) {
            redirect ( 'login', 'refresh' );
        }
        $this->load->vars ( array (
                'global' => 'Available to all views',
                'header' => 'common/header',
                'left' => 'common/left',
                'footer' => 'common/footer' 
        ) ); 
        $this->load->model('Color_model');
        $this->load->model('Product_model');
        $this->load->library('Fileupload');
    } 
    
    public function index(){
          $data['import_list'] = $this->Color_model->getAllImportData();			
          $data['vendor_list'] = $this->Product_model->get_vendor();
//       echo "<pre>";
//        print_r($data);
//        exit();		
          
		
        $this->load->view('export_products',$data);
    }

    public function checkVendor(){
        $vendor_id = (int)$this->input->post('vendor');

        $arr_allow_vendors = array(55, 44, 33, 8, 119 , 24);
        if(in_array($vendor_id, $arr_allow_vendors)){
            $this->surya($vendor_id);
        }else{
            $this->session->set_flashdata('error', 'Export option is not available for this vendor!');
             redirect(base_url().'Export_products');
        } 
    }

    public function surya($vendor_id)
    {
        
         $filename = 'rugs_'.date('Ymd').'.csv'; 
         header("Content-Description: File Transfer"); 
         header("Content-Disposition: attachment; filename=$filename"); 
         header("Content-Type: application/csv; ");

         // get data 
         $query   = $this->db->query("SELECT * FROM rugs_tmp WHERE _vendor=$vendor_id AND new_arrival = 0 AND isResidential = 1 Limit 10;");
         //echo $query;exit;
         $results = $query->result_array();
         //echo 'Total Results: ' . count($results);exit;
         $i = 0;
         $surya_exp = array();
         
         // Format shopify structure 
         foreach ($results as $row) {

            $variations = json_decode($row['variations']);
            $arr_tag_size = [];
            foreach($variations as $variation){
                $searchSize = '';
                if (property_exists($variation, 'searchSize')){
                    $searchSize = $variation->searchSize;
                }
                if (property_exists($variation, 'searchsize')){
                    $searchSize = $variation->searchsize;
                }
                if(!empty($searchSize)){
                    $this->updateSearchSize($searchSize);
                }
                $arr_tag_size[] = 'Size_'.$searchSize;
            }
            $tag_size = implode(' ,', $arr_tag_size);

            $lead_time = '';
            if($row['quality'] == 'Hand Knotted'){
                $lead_time = 'lead time_14';
            }elseif ($row['quality'] == 'Hand Loomed') {
                $lead_time = 'lead time_6';
            }

            $tags = "category_".$row['category'].", color_".$row['color'].", ".$lead_time.", material_".$row['material'].", origin_India, quality_".$row['quality'].", ".$tag_size.", Sector_".$row['sector'].", vendor_".$row['vendor'];

            $seo_desc = "category ".$row['category'].", color ".$row['color'].", lead time 14, material ".$row['material'].", origin India, quality ".$row['sector'].", Sector ".$row['quality'].", vendor ".$row['vendor'];



            $name_url = str_replace(' ', '-', strtolower($row['vendor']));

            $v = 0;
            foreach($variations as $variation){
                if((int)$variation->active == 1){
                    if($v == 0){
                    $surya_exp[$i]['handle']                        = $name_url;
                    $surya_exp[$i]['title']                         = $row['name'];
                    $surya_exp[$i]['body']                          = $row['description'];
                    $surya_exp[$i]['vendor']                        = $row['vendor'];
                    $surya_exp[$i]['standardized_product_type']     = '';
                    $surya_exp[$i]['custom_product_type']           = 'Rug';
                    $surya_exp[$i]['tags']                          = $tags;
                    $surya_exp[$i]['published']                     = 'True';
                    $surya_exp[$i]['option1_name']                  = 'Size';
                    $surya_exp[$i]['option1_value']                 = $variation->size;
                    $surya_exp[$i]['option2_name']                  = '';
                    $surya_exp[$i]['option2_value']                 = '';
                    $surya_exp[$i]['option3_name']                  = '';
                    $surya_exp[$i]['option3_value']                 = '';
                    $surya_exp[$i]['variant_SKU']                   = $variation->sizeSku;
                    $surya_exp[$i]['variant_grams']                 = '';
                    $surya_exp[$i]['variant_inventory_tracker']     = '';
                    $surya_exp[$i]['variant_inventory_policy']      = 'deny';
                    $surya_exp[$i]['variant_fulfillment_service']   = 'manual';
                    $surya_exp[$i]['variant_fulfillment_service']   = 'manual';
                    $surya_exp[$i]['variant_price']                 = $variation->price;
                    $surya_exp[$i]['variant_compare_at_price']      = '';
                    $surya_exp[$i]['variant_requires_shipping']     = 'TRUE';
                    $surya_exp[$i]['variant_taxable']               = 'TRUE';
                    $surya_exp[$i]['variant_barcode']               = '';
                    $surya_exp[$i]['image_src']                     = 'https://www.modernrugs.com'.$row['large_pic'];
                    $surya_exp[$i]['image_position']                = '1';
                    $surya_exp[$i]['image_alt_text']                = $row['name'];
                    $surya_exp[$i]['gift_card']                     = 'FALSE';
                    $surya_exp[$i]['SEO_title']                     = $row['name'];
                    $surya_exp[$i]['SEO_Description']               = $row['description'];
                    $surya_exp[$i]['google_shopping_category']      = '598';
                    $surya_exp[$i]['google_shopping_gender']        = 'unisex';
                    $surya_exp[$i]['google_shopping_age_group']     = '';
                    $surya_exp[$i]['google_shopping_MPN']           = '';
                    $surya_exp[$i]['google_shopping_adWords_group'] = '';
                    $surya_exp[$i]['google_shopping_adWords_labels']= '';
                    $surya_exp[$i]['google_shopping_condition']     = 'NEW';
                    $surya_exp[$i]['google_shopping_custom_product']= 'FALSE';
                    $surya_exp[$i]['google_shopping_custom_label_0']= $row['vendor'];;
                    $surya_exp[$i]['google_shopping_custom_label_1']= $name_url;
                    $surya_exp[$i]['google_shopping_custom_label_2']= '';
                    $surya_exp[$i]['google_shopping_custom_label_3']= '';
                    $surya_exp[$i]['google_shopping_custom_label_4']= '';
                    $surya_exp[$i]['variant_image']= '';
                    $surya_exp[$i]['variant_weight_unit']= 'kg';
                    $surya_exp[$i]['variant_tax_code']= '';
                    $surya_exp[$i]['cost_per_item']= '';
                    $surya_exp[$i]['status']= 'Active';

                }else{

                    $surya_exp[$i]['handle']                        = $name_url;
                    $surya_exp[$i]['title']                         = '';
                    $surya_exp[$i]['body']                          = '';
                    $surya_exp[$i]['vendor']                        = '';
                    $surya_exp[$i]['standardized_product_type']     = '';
                    $surya_exp[$i]['custom_product_type']           = '';
                    $surya_exp[$i]['tags']                          = '';
                    $surya_exp[$i]['published']                     = '';
                    $surya_exp[$i]['option1_name']                  = '';
                    $surya_exp[$i]['option1_value']                 = $variation->size;
                    $surya_exp[$i]['option2_name']                  = '';
                    $surya_exp[$i]['option2_value']                 = '';
                    $surya_exp[$i]['option3_name']                  = '';
                    $surya_exp[$i]['option3_value']                 = '';
                    $surya_exp[$i]['variant_SKU']                   = $variation->sizeSku;
                    $surya_exp[$i]['variant_grams']                 = '';
                    $surya_exp[$i]['variant_inventory_tracker']     = '';
                    $surya_exp[$i]['variant_inventory_policy']      = 'deny';
                    $surya_exp[$i]['variant_fulfillment_service']   = 'manual';
                    $surya_exp[$i]['variant_price']                 = $variation->price;
                    $surya_exp[$i]['variant_compare_at_price']      = '';
                    $surya_exp[$i]['variant_requires_shipping']     = 'TRUE';
                    $surya_exp[$i]['variant_taxable']               = 'TRUE';
                    $surya_exp[$i]['variant_barcode']               = '';
                    $surya_exp[$i]['image_src']                     = '';
                    $surya_exp[$i]['image_position']                = '';
                    $surya_exp[$i]['image_alt_text']                = '';
                    $surya_exp[$i]['gift_card']                     = '';
                    $surya_exp[$i]['SEO_title']                     = '';
                    $surya_exp[$i]['SEO_Description']               = '';
                    $surya_exp[$i]['google_shopping_category']      = '598';
                    $surya_exp[$i]['google_shopping_gender']        = '';
                    $surya_exp[$i]['google_shopping_age_group']     = '';
                    $surya_exp[$i]['google_shopping_MPN']           = '';
                    $surya_exp[$i]['google_shopping_adWords_group'] = '';
                    $surya_exp[$i]['google_shopping_adWords_labels']= '';
                    $surya_exp[$i]['google_shopping_condition']     = 'NEW';
                    $surya_exp[$i]['google_shopping_custom_product']= 'FALSE';
                    $surya_exp[$i]['google_shopping_custom_label_0']= '';
                    $surya_exp[$i]['google_shopping_custom_label_1']= '';
                    $surya_exp[$i]['google_shopping_custom_label_2']= '';
                    $surya_exp[$i]['google_shopping_custom_label_3']= '';
                    $surya_exp[$i]['google_shopping_custom_label_4']= '';
                    $surya_exp[$i]['variant_image']= '';
                    $surya_exp[$i]['variant_weight_unit']= 'kg';
                    $surya_exp[$i]['variant_tax_code']= '';
                    $surya_exp[$i]['cost_per_item']= '';
                    $surya_exp[$i]['status']= '';

                }
                $i++;
                $v++;
                }
                
            }           
            
         }
         //print_r($surya_exp);
         //exit;

         // file creation 
         $file = fopen('php://output', 'w');

         $header = array("Handle","Title","Body (HTML)","Vendor","Standardized Product Type","Custom Product Type","Tags","Published","Option1 Name","Option1 Value","Option2 Name","Option2 Value","Option3 Name","Option3 Value","Variant SKU","Variant Grams","Variant Inventory Tracker","Variant Inventory Policy","Variant Fulfillment Service","Variant Price","Variant Compare At Price","Variant Requires Shipping","Variant Taxable","Variant Barcode","Image Src","Image Position","Image Alt Text","Gift Card","SEO Title","SEO Description","Google Shopping / Google Product Category","Google Shopping / Gender","Google Shopping / Age Group","Google Shopping / MPN","Google Shopping / AdWords Grouping","Google Shopping / AdWords Labels","Google Shopping / Condition","Google Shopping / Custom Product","Google Shopping / Custom Label 0","Google Shopping / Custom Label 1","Google Shopping / Custom Label 2","Google Shopping / Custom Label 3","Google Shopping / Custom Label 4","Variant Image","Variant Weight Unit","Variant Tax Code","Cost per item","Status"); 
         fputcsv($file, $header);
         //print_r($results);exit;
         foreach ($surya_exp as $row) {
            fputcsv($file, $row); 
         }
         fclose($file); 
         exit; 
        
        

        
        
        return view('rug_surya');
    }


    public function updateSearchSize($searchSize){
        if(!empty($searchSize)){
            $numRows =  $this->db->select('*')->from('search_sizes')
                        ->where(array('size'=>$searchSize))
                        ->get()
                        ->num_rows();
            if($numRows == 0){  
                //$results = $query->result_array();
                $data = array(
                    'size'=>$searchSize
                );

                $this->db->insert('search_sizes',$data);

            }

           
        }
    }
    
   
}